import mechanize
import os
import time




# Laedt alle Unterseiten einer angebenen URL und speichert diese
def main():

	# Liste aller Endungen die weggelassen werden sollen
	global extensionlist 
	extensionlist = []

	#init Browser
	global browser	
	browser= mechanize.Browser()
	browser.set_handle_robots(False)
	browser.set_handle_equiv(False)
	browser.addheaders = [('User-agent', 'Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.0.1) Gecko/2008071615 Fedora/3.0.1-1.fc9 Firefox/3.0.1')]

	# Ausgangsurl ueber die gecrawlt wird
	global rootUrl	
	rootUrl = "" 
	# Liste mit allen Links von der rootUrl
	global linkList	
	linkList = []
	global allreadyVisitedLinks
	allreadyVisitedLinks = []
	#setRootUrlman()

	setRootUrl('https://www.dkrz.de')

        #holt HTML code der Root url befuellt die linklist zum ersten mal und speichert HTML in File
	htmlCode = getHtml(rootUrl)
	linkList = getLinksOutOfHtml(htmlCode)
	saveHtmlIntoFile(htmlCode, rootUrl)

        # merkt sich alle bereit besuchten URLS
	allreadyVisitedLinks.append(rootUrl)
	
	# geht alle links durch und speichert HTML code + neue Links
	while(linkList):
		newAddedLinks = []		
		for link in linkList:
			try:
				Html = getHtml(link)
				newAddedLinks.extend(getLinksOutOfHtml(Html))
				saveHtmlIntoFile(Html, link)
				allreadyVisitedLinks.append(link)
			except:
				extensionlist.append(link)
		linkList = []
		newAddedLinks = set (newAddedLinks)		
		for link in newAddedLinks:
			if (link not in allreadyVisitedLinks and link not in linkList):
				linkList.append(link)
		#print("\n\n############\n[main]:: still " + str(len(linkList)) + " Links to process.\n############\n\n")

	#print("\n\n\n" + extensionlist) 
	 
			


# Methode zur Eingabe der rootUrl ueber Kommandozeile
def setRootUrlman():
	global rootUrl
	rootUrl = raw_input("Bitte geben Sie eine URL an.")

# Methode zur Eingabe der rootUrl
def setRootUrl(Urlname):
	global rootUrl
	rootUrl = Urlname

# Methode zum Oeffnen der Html
def getHtml(Url):
	start = time.time()
	print("\t[getHtml]:: got HTMLCODE from: " + Url)	
	global browser
	response = browser.open(Url)
	print ("getHTML " + str(time.time()-start))
	return response.read()

# Methode zum Sammeln der Links innerhalb der Html
def getLinksOutOfHtml(Html):
	start = time.time()	
	global rootUrl	
	quoteFound = False	
	result = []
	currentLink = ""	
	HtmlCodeSplitted = []	
	HtmlCodeSplitted = Html.splitlines()
	
	# Sucht in dem Html Text nach Links und speichert diese ab.
	for line in HtmlCodeSplitted:
		if("<a" in line):
			currentLink = ""
			for character in line:
				if (quoteFound == False):
					if(character == '"'):
						quoteFound = True
				else:
					if(character == '"'):
						quoteFound = False
						break
					else:
						currentLink += character
			if(rootUrl in currentLink):
				result.append(currentLink)
				#print("[]____\n" + line + "\n" + currentLink + "\n\n")	
	print ("getLinks " + str(time.time()-start))	
	return result

# Speichert die Html Datei im Verzeichnis als .txt ab.
def saveHtmlIntoFile(Html, Url):
	start = time.time()	
	directory = "HtmlTextDerSeiten"
	if not os.path.exists(directory):
		os.makedirs(directory)
	Url = Url.replace("/", "_")
	htmlFilename = directory+"/"+Url.split('www.')[1]+".html"
	htmlFile = open(htmlFilename, "w+")
	htmlFile.write(Html)
	htmlFile.close()
	print ("saveHTML " + str(time.time()-start))
	
def checkUrlThatsNotFile(Url):
	result = False
	result = Url.endwith((".jpg",".mp4",""))
	
	
	


main()
