import mechanize
import os
import time

		
def is_ascii(s):
    return all(ord(c) < 128 for c in s)

def main():

	#
	# Initialize Variables
	#
	currentWorkingDirectory = os.getcwd()
	parentDirectoryOfCWD = os.path.dirname(os.path.normpath(currentWorkingDirectory))
	directoryToAnalyze = parentDirectoryOfCWD + "\\textbypython\\"
	allFilesInDirectory = os.listdir(directoryToAnalyze)
	allFilesToAnalyze=[]
	goalFolder = parentDirectoryOfCWD + "\\statistics\\"
	if not os.path.exists(goalFolder):
		os.makedirs(goalFolder)
	allWordCounter={}


	#
	# Ignore Non Ascii Files (Like pdf, mp4 etc)
	#
	for files in allFilesInDirectory:
		with open(directoryToAnalyze+files) as currentFile:
			fileContent = currentFile.read()
			#if(is_ascii(fileContent)):
			allFilesToAnalyze.append(files)
	#difference = len(allFilesInDirectory) - len(allFilesToAnalyze)
	#print(str(difference) + " Error Files.")
	difference = 0
	allFilesInDirectory=[]


	#
	# Analyze Files
	#

	for files in allFilesToAnalyze:
		with open(directoryToAnalyze+files) as currentFile:		
			fileContent = currentFile.read()
			fileContent = fileContent.lower()
		
			# Clean up File
			fileContent = fileContent.replace("."," ")
			fileContent = fileContent.replace(","," ")
			fileContent = fileContent.replace("?"," ")
			fileContent = fileContent.replace("!"," ")
			fileContent = fileContent.replace("/"," ")
			fileContent = fileContent.replace("<"," ")
			fileContent = fileContent.replace(">"," ")
			fileContent = fileContent.replace("("," ")
			fileContent = fileContent.replace(")"," ")
			fileContent = fileContent.replace("["," ")
			fileContent = fileContent.replace("]"," ")
			fileContent = fileContent.replace("\\"," ")
			fileContent = fileContent.replace(";"," ")
			fileContent = fileContent.replace(":"," ")
			fileContent = fileContent.replace("#"," ")
			fileContent = fileContent.replace("*"," ")
			fileContent = fileContent.replace("&"," ")
			fileContent = fileContent.replace("%"," ")
			fileContent = fileContent.replace("'"," ")
			fileContent = fileContent.replace("  "," ")
		
			# Content to list of words
			allWords = fileContent.split()
			wordcounter = {}
			# Count all Words
			for word in allWords:
				if(word in wordcounter.keys()):
					wordcounter[word]=(wordcounter[word] + 1)
					allWordCounter[word]=(allWordCounter[word] + 1)
				else:
					wordcounter[word] = 1
					allWordCounter[word] = 1
		
			# Write statistic File for this one file
			print(wordcounter)
			statsFile = open(goalFolder + files, "w")
			for key in wordcounter:
				statsFile.write(key + "---" + str(wordcounter[key]) + "__;\n")
			statsFile.close()
	# Write statistic File for all Files	
	allStatsFile = open(goalFolder + "allWords.txt", "w")
	for key in allWordCounter:
		allStatsFile.write(key + "---" + str(allWordCounter[key]) + "__;\n")
	allStatsFile.close()	

main()



